//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

// MXCSRbit錾
typedef struct {
    unsigned    ie:1,
                de:1,
                ze:1,
                oe:1,
                ue:1,
                pe:1,
                :1,
                im:1,
                dm:1,
                zm:1,
                om:1,
                um:1,
                pm:1,
                rc:2,
                fz:1,
                :16;
} mxcsr_bits ;


// MXCSR\
void dispMxcsr( void )
{
    union  {
        mxcsr_bits   bit ;
        unsigned int reg ;
    } mxcsr ;

    __asm   stmxcsr  mxcsr.reg

    printf("        tO(IE):%d\n",mxcsr.bit.ie);
    printf("    fm[}EtO(DE):%d\n",mxcsr.bit.de);
    printf("        [ZtO(ZE):%d\n",mxcsr.bit.ze);
    printf("I[o[t[EtO(OE):%d\n",mxcsr.bit.oe);
    printf("A_[t[EtO(UE):%d\n",mxcsr.bit.ue);
    printf("            xtO(PE):%d\n",mxcsr.bit.pe);
    printf("\n");

    printf("        }XN(IM):%d\n",mxcsr.bit.im);
    printf("    fm[}E}XN(DM):%d\n",mxcsr.bit.dm);
    printf("        [Z}XN(ZM):%d\n",mxcsr.bit.zm);
    printf("I[o[t[E}XN(OM):%d\n",mxcsr.bit.om);
    printf("A_[t[E}XN(UM):%d\n",mxcsr.bit.um);
    printf("            x}XN(PM):%d\n",mxcsr.bit.pm);
    printf("\n");

    printf("              ۂߐ(RC):%d\n",mxcsr.bit.rc);
    printf("      [EtbV(FZ):%d\n",mxcsr.bit.fz);
}

//C
int main( int argc, char *argv[] )
{
    double src[2], dst[2];

    src[0] = src[1] = 0.0f;
    dst[0] = dst[1] = 1.0f;

    printf(" ---------- l ---------- \n");
    dispMxcsr();

    __asm
    {
        movdqu  xmm0, src
        movdqu  xmm1, dst
        divpd   xmm1, xmm0  // ZERO Divide
    }

    printf("\n ------ ZERO DIVIDE --- \n");
    dispMxcsr();

    return 0;
}
