// movq_mmx.c
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

//------------------------------------------------------
// get counter
long long getCurCounter(void)
{
    long long  counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}

//------------------------------------------------------
// main
int main( int argc, char *argv[] )
{
    long long begin, finish, elapsed1,elapsed2 ;    // \\
    unsigned int src[] = {0x89abcdef, 0x01234567};
    unsigned int dst[]={0,0};

    // movntq -------------------------
    begin = getCurCounter();
    __asm
    {
        mov         ecx, 100000
    
    loop1:
        movq    mm0, src
        movntq  dst, mm0
        loop    loop1

        emms
    }
    finish = getCurCounter();
    elapsed1 = finish > begin ? finish - begin : begin - finish ;

    printf("source: %08x%08x\n", src[1], src[0]);
    printf("result: %08x%08x\n", dst[1], dst[0]);
    printf("movntq= %I64u clocks.\n\n", elapsed1 ) ;



    // movq ---------------------------
    begin = getCurCounter();
    __asm
    {
        mov     ecx, 100000
    
    loop2:
        movq    mm0, src
        movq    dst, mm0
        loop    loop2

        emms
    }
    finish = getCurCounter();
    elapsed2 = finish > begin ? finish - begin : begin - finish ;

    printf("source: %08x%08x\n", src[1], src[0]);
    printf("result: %08x%08x\n", dst[1], dst[0]);
    printf("  movq= %I64u clocks.\n\n", elapsed2 ) ;

    printf("\"movq\" about %I64u times faster than \"movntq\".\n",
                                                elapsed1/elapsed2 ) ;

    return 0;
}
