//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>
#include <stdlib.h>


//------------------------------------------------------
// get counter
long long getCurCounter(void)
{
    long long  counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}

//------------------------------------------------------
// main
int main( int argc, char *argv[] )
{
    long long begin, finish, elapsed1,elapsed2 ;    // \\
    __declspec(align(16)) float dat0[4]={0,0,0,0};
    __declspec(align(16)) float dat1[4]={1.0f,1.0f,1.0f,1.0f};

    // movntps -------------------------
    begin = getCurCounter();
    __asm
    {
        mov     ecx, 100000

    loop1:
        movaps  xmm0, dat0
        addps   xmm0, dat1
        movntps dat0, xmm0
        loop    loop1
    }
    finish = getCurCounter();
    elapsed1 = finish > begin ? finish - begin : begin - finish ;

    printf("movntps= %I64u clocks.\n\n", elapsed1 ) ;



    // movaps -------------------------
    begin = getCurCounter();
    __asm
    {
        mov     ecx, 100000

    loop2:
        movaps  xmm0, dat0
        addps   xmm0, dat1
        movaps  dat0, xmm0
        loop    loop2
    }
    finish = getCurCounter();
    elapsed2 = finish > begin ? finish - begin : begin - finish ;

    printf("movaps = %I64u clocks.\n\n", elapsed2 ) ;

    printf("\"movaps\" %2.3f times faster than \"movntps\".\n",
                                        (double)elapsed1/(double)elapsed2 ) ;

    return 0;
}