// movq_mmx.c
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

//------------------------------------------------------
// get counter
long long getCurCounter(void)
{
    long long  counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}

//------------------------------------------------------
// main
int main( int argc, char *argv[] )
{
    long long begin, finish, elapsed1,elapsed2 ;    // \\
    double src[2];
    __declspec(align(16)) double dst[2]={0,0};

    // movntq -------------------------
    begin = getCurCounter();
    __asm
    {
        mov         ecx, 100000

    loop1:
        movupd      xmm0, src
        movntpd     dst,  xmm0
        loop        loop1
    }
    finish = getCurCounter();
    elapsed1 = finish > begin ? finish - begin : begin - finish ;
    printf("movntpd= %I64u clocks.\n\n", elapsed1 ) ;



    // movq ---------------------------
    begin = getCurCounter();
    __asm
    {
        mov			ecx, 100000

    loop2:
        movupd      xmm0, src
        movupd      dst,  xmm0
        loop        loop2
    }
    finish = getCurCounter();
    elapsed2 = finish > begin ? finish - begin : begin - finish ;
    printf(" movupd= %I64u clocks.\n\n", elapsed2 ) ;

    printf("\"movupd\" %2.3f times faster than \"movntpd\".\n",
                                        (double)elapsed1/(double)elapsed2 ) ;

    return 0;
}
