// movq_mmx.c
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

//------------------------------------------------------
// get counter
long long getCurCounter(void)
{
    long long  counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}

//------------------------------------------------------
// main
int main( int argc, char *argv[] )
{
    long long begin, finish, elapsed1,elapsed2 ;    // \\
    unsigned int src[]={0x01234567,0x89abcdef,0xfedcba98,0x76543210};
    __declspec(align(16)) unsigned int dst[4];

    // movntq -------------------------
    begin = getCurCounter();
    __asm
    {
        mov         ecx, 100000

    loop1:
        movdqu      xmm0,  src
        movntdq     dst,   xmm0
        loop        loop1
    }
    finish = getCurCounter();
    elapsed1 = finish > begin ? finish - begin : begin - finish ;
    printf("movntdq= %I64u clocks.\n\n", elapsed1 ) ;



    // movq ---------------------------
    begin = getCurCounter();
    __asm
    {
        mov         ecx, 100000

    loop2:
        movdqu      xmm0,  src
        movdqa      dst,   xmm0
        loop        loop2
    }
    finish = getCurCounter();
    elapsed2 = finish > begin ? finish - begin : begin - finish ;
    printf(" movdqa= %I64u clocks.\n\n", elapsed2 ) ;

    printf("\"movdqa\" %2.3f times faster than \"movntdq\".\n",
                                        (double)elapsed1/(double)elapsed2 ) ;

    return 0;
}
