// movq_mmx.c
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
#include <stdio.h>

//------------------------------------------------------
// get counter
long long getCurCounter(void)
{
    long long  counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}

//------------------------------------------------------
// main
int main( int argc, char *argv[] )
{
    long long begin, finish, elapsed1,elapsed2 ;    // \\
    int src=0x01234567;
    int dst=0;;

    // movntq -------------------------
    begin = getCurCounter();
    __asm
    {
        mov         ecx, 100000

    loop1:
        mov         eax, src
        movnti      dst, eax
        loop        loop1
    }
    finish = getCurCounter();
    elapsed1 = finish > begin ? finish - begin : begin - finish ;
    printf("movnti= %I64u clocks.\n\n", elapsed1 ) ;



    // movq ---------------------------
    begin = getCurCounter();
    __asm
    {
        mov         ecx, 100000

    loop2:
        mov         eax, src
        mov         dst, eax
        loop        loop2
    }
    finish = getCurCounter();
    elapsed2 = finish > begin ? finish - begin : begin - finish ;
    printf("   mov= %I64u clocks.\n\n", elapsed2 ) ;

    printf("\"mov\" %2.3f times faster than \"movnti\".\n",
                                        (double)elapsed1/(double)elapsed2 ) ;

    return 0;
}
