//
// 4 x 4 Z
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                                    Kitayama, Hiroyuki
//
//
#include <stdio.h>

void virt_add4x4(float *src, float *dst)
{
    _asm
    {
        mov     ecx, src            // load structure addresses
        mov     edx, dst

        movups  xmm0, [ecx]         // load A1 A2 A3 A4 => xmm0
        movups  xmm1, [ecx+16]      // load B1 B2 B3 B4 => xmm1
        movups  xmm2, [ecx+32]      // load C1 C2 C3 C4 => xmm2
        movups  xmm3, [ecx+48]      // load D1 D2 D3 D4 => xmm3

                                    // START HORIZONTAL ADD
        addps   xmm0, xmm1          // A+B
        addps   xmm0, xmm2          // A+B+C
        addps   xmm0, xmm3          // A+B+C+D

        movups [edx], xmm0
    }
}

// main
int main( void )
{
    int i;
    float src[] = {   1,   2,   3,   4,
                      5,   6,   7,   8,
                      9,  10,  11,  12,
                     13,  14,  15,  16
    };
    float dst[] = {   0,   0,   0,   0};

    virt_add4x4( src, dst);

    printf("\n<<<<ADD 4x4 >>>>\n") ;
    printf("------ src -------- ") ;
    for(i=0;i<(sizeof(src)/sizeof(src[0]));i++)
    {
        if( 0 == i % 4 )
             printf("\n");
        printf(" %3.0f", src[i]) ;
    }
    printf("\n------ dst -------- \n") ;
    for(i=0;i<(sizeof(dst)/sizeof(dst[0]));i++)
         printf(" %3.0f", dst[i]);

    return 0;
}
