//---------------------------------------------------------------------------
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//

//---------------------------------------------------------------------------
#include <stdio.h>
#include <windows.h>

#include "Cbmp.h"


//---------------------------------------------------------------------------
//
// RXgN^
//
Cbmp::Cbmp( void )
{
    try
    {                           // e
        pDib        = NULL ;    // DIBւ̃|C^
        pBitmap     = NULL ;    // rbg}bv{̂ւ̃|C^
        bmpFName[0] = '\0' ;    // rbg}bvt@C
    }
    catch( ... )
    {
    }
}


//---------------------------------------------------------------------------
//
// fXgN^
//
Cbmp::~Cbmp( void )
{
    SAFE_FREE( pDib ) ;     // rbg}bvIuWFNg폜
}


////////////////// private\bh /////////////////////
//
// rbgb}vwb_̓ǂݍ
//
bool Cbmp::readHeader( FILE* fp, PBITMAPFILEHEADER bmFileHdr )
{
    // rbgb}vwb_̓ǂݍ
    if( fread( bmFileHdr, sizeof(BITMAPFILEHEADER), 1, fp ) !=  1 )
    {
        return false ;
    }

    // rbgb}vt@C`FbN
    if ( bmFileHdr->bfType != 'M'*256+'B' )
    {
        return false ;
    }
    return true ;
}


//---------------------------------------------------------------------------
//
// rbgb}v{̂̓ǂݍ
//
bool Cbmp::readBody( FILE* fp, PBITMAPFILEHEADER bmFileHdr, PBITMAPINFOHEADER pDib )
{
    int bitmapSize ;

    bitmapSize = bmFileHdr->bfSize - sizeof(BITMAPFILEHEADER) ;   // 摜̑傫

    if( fread( pDib , bitmapSize, 1, fp ) !=  1 )       // rbgb}v{̂̓ǂݍ
    {
        return false ;
    }
    return true ;
}
////////////////// ܂private\bh /////////////////////


//---------------------------------------------------------------------------
//
// t@C̎擾
//
bool Cbmp::getFname( char* inFname )
{
    OPENFILENAME fName ;
    const char filefilter[] = "BMPt@C(*.bmp)\0*.bmp\0\0" ;

    bmpFName[0] = '\0' ;

    memset( &fName, 0, sizeof(OPENFILENAME) ) ;
    fName.lStructSize    = sizeof(OPENFILENAME) ;
    fName.lpstrFilter    = filefilter ;
    fName.nFilterIndex   = 1 ;
    fName.lpstrFile      = bmpFName ;
    fName.nMaxFile       = sizeof(bmpFName) ;
    fName.Flags          = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY ;

    if( GetOpenFileName( &fName ) == 0 )    // ut@CJv_CAO
        return false ;

    strcpy( inFname, bmpFName ) ;

    return true ;
}


//---------------------------------------------------------------------------
//
// extract file name
//
void Cbmp::extFname( char* inFName )
{
    char dfName[_MAX_FNAME], dfExt[_MAX_EXT ] ;

    // t@C̎o
    _splitpath( bmpFName, NULL, NULL, dfName, dfExt ) ;
    strcpy( inFName, dfName ) ;
    strcat( inFName, dfExt ) ;
}


//---------------------------------------------------------------------------
//
// rbg}bṽ[h
//
// return true :
//        false:s
//
bool Cbmp::LoadFromFile( char* bmpFName )
{
    FILE* fp ;
    int bitmapSize ;
    bool rVal = true ;

    try
    {
        SAFE_FREE( pDib ) ;             // 

        // rbg}bvt@C̃I[v
        if( (fp = fopen( bmpFName, "rb" )) == NULL )
            return false ;

        // wb_̓ǂݍ
        if( !readHeader( fp, &bmFileHdr ) )
        {
            fclose( fp ) ;          // t@CN[Y
            return false ;
        }

        // rbg}bv{̂̃TCY
        bitmapSize = bmFileHdr.bfSize - sizeof(BITMAPFILEHEADER) ;

        // m
        pDib = (BITMAPINFOHEADER *)malloc( bitmapSize ) ;

        // {̓ǂݍ
        if( !readBody( fp, &bmFileHdr, pDib ) )
        {
            SAFE_FREE( pDib ) ;         // 
            fclose( fp ) ;              // t@CN[Y
            return false ;
        }

        fclose( fp ) ;                  // t@CN[Y

        // |C^rbg}bv{̈ʒuֈړ
        pBitmap = (BYTE *)(pDib) + bmFileHdr.bfOffBits
                                        - sizeof(BITMAPFILEHEADER) ;
    }
    catch( ... )
    {
        rVal = false ;
    }
    return rVal ;
}


//---------------------------------------------------------------------------
//
// rbg}bv擾
//
unsigned int Cbmp::getWidth( void )
{
    if( pDib == NULL )
        return (unsigned int)0 ;

    return (unsigned int)pDib->biWidth ;
}


//---------------------------------------------------------------------------
//
// rbg}bv擾
//
unsigned int Cbmp::getHeight( void )
{
    if( pDib == NULL )
        return (unsigned int)0 ;

    return (unsigned int)pDib->biHeight ;
}


//---------------------------------------------------------------------------
//
// rbg}bvS
//
PBITMAPINFOHEADER Cbmp::getPdib( void )
{
    return pDib ;
}


//---------------------------------------------------------------------------
//
// rbg}bv{
//
LPBYTE Cbmp::getPbitmapBody( void )
{
    if( pDib == NULL )
        return NULL ;

    return pBitmap ;
}


//---------------------------------------------------------------------------
//
// 24bit rbg}bv
//
bool Cbmp::is24bit( void )
{
    if( pDib->biBitCount == 24 )  // 24 bits bitmap ?
        return true ;
    else
        return false ;
}



//---------------------------------------------------------------------------
//
// 32bit rbg}bv
//
bool Cbmp::is32bit( void )
{
    if( pDib->biBitCount == 32 )  // 32 bits bitmap ?
        return true ;
    else
        return false ;
}