//
// pgm.cpp
//
// (c)Copyright Spacesoft corp., 2007 All rights reserved.
//                               Hiro KITAYAMA
//
#include <stdio.h>
#include <windows.h>
#include "resource.h"

#include "Cbmp.h"
Cbmp* spCbmp[2] = { NULL, NULL};
LPBYTE pAligned[2] ={NULL,NULL};    // SIMDpobt@

#define SZCLASSNAME         "SIMD"
#define ID_TIMER            1
#define NUM_OF_LOOP         10

void effectC   ( LPBYTE pAligned[], LONG width, LONG height );   //C֐
void effectAsm ( LPBYTE pAligned[], LONG width, LONG height );   //Asm֐
void effectSimd( LPBYTE pAligned[], LONG width, LONG height );   //SIMD֐
void (*pFunc)  ( LPBYTE pAligned[], LONG width, LONG height );   //֐|C^



//---------------------------------------------------------------------------
//
// t@Cǂݍ
//
// spCbmp[0] ... for draw to screen
// spCbmp[1] ... holds original images
//
void openFile( HWND hWnd )
{
    char  fName[_MAX_PATH] ;
    int  imgSize ;

    try
    {
        spCbmp[0] = new Cbmp() ;                    // NX̃CX^X
        spCbmp[0] -> getFname( fName ) ;            // Ȃ
        if( !spCbmp[0] -> LoadFromFile( fName ) )   // t@Cǂݍ
        {
            SAFE_DELETE( spCbmp[0] ) ;              // IuWFNg
            SetWindowText( hWnd, "G[Fǂݍݎs" );
            return ;
        }
        if( spCbmp[0]->is32bit() == false )
        {
            SAFE_DELETE( spCbmp[0] ) ;              // IuWFNg
            SetWindowText( hWnd, "G[F32rbgBMPłȂ" );
            return;
        }
        if( spCbmp[0]->getWidth() % 4 )
        {
            SAFE_DELETE( spCbmp[0] ) ;              // IuWFNg
            SetWindowText( hWnd, "G[F4 oCg̐{łȂ" );
            return;
        }

        spCbmp[1] = new Cbmp() ;                    // NX̃CX^X
        if( !spCbmp[1] -> LoadFromFile( fName ) )   // t@Cǂݍ
        {
            SAFE_DELETE( spCbmp[0] ) ;              // IuWFNg
            SAFE_DELETE( spCbmp[1] ) ;              // IuWFNg
            SetWindowText( hWnd, "G[Fǂݍݎs" );
            return ;
        }
    }
    catch( ... )
    {
    }
}


//---------------------------------------------------------------------------
//
// EBhETCY̕ύX
//
void chgWinSize( HWND hWnd )
{
    RECT rc, rcClient ;
    int  winHeight, winWidth ;
    char fileName[_MAX_PATH] ;

    try
    {
        if( spCbmp[0] == NULL )
            return ;

        spCbmp[0] -> extFname( fileName ) ;     //t@C\
        SetWindowText( hWnd, fileName );

        GetWindowRect( hWnd, &rc ) ;            //EBhETCY𒲐
        GetClientRect( hWnd, &rcClient ) ;
        winWidth  = spCbmp[0]->getWidth() ;
        winHeight = spCbmp[0]->getHeight() ;
        winWidth  += (rc.right-rc.left) - (rcClient.right-rcClient.left);
        winHeight += (rc.bottom-rc.top) - (rcClient.bottom-rcClient.top);
        MoveWindow( hWnd, rc.left, rc.top, winWidth, winHeight, TRUE );
    }
    catch( ... )
    {
    }
}


//---------------------------------------------------------------------------
//
// get counter
//
UINT64 getCurCounter(void)
{
    UINT64 counter ;         // \\

    _asm
    {
        rdtsc
        mov     dword ptr [counter+0], eax
        mov     dword ptr [counter+4], edx
    }

    return counter;
}


//---------------------------------------------------------------------------
//
// s
//
// pAligned[0] ... pointer to allocated aligned image memory.
// pAligned[1] ... pointer to aligned image memory.
//
bool doPrepareExec( HWND hWnd )
{
    int  imgSize ;
    bool rVal;

    if( spCbmp[0]==NULL )
        return false ;

    SAFE_ALIGNED_FREE(pAligned[0]); // 

    imgSize=spCbmp[0]->getWidth() * spCbmp[0]->getHeight() * 4;

    // alignꂽm
    pAligned[0] = (LPBYTE)_aligned_malloc(imgSize*2, 16);   // dst
    if( pAligned[0]==NULL)
    {
        pAligned[0]=NULL;

        rVal=false;
    }
    else
    {
        pAligned[1] = pAligned[0] + imgSize;                // src

        // alignꂽGAɃRs[
        memcpy(pAligned[1], spCbmp[1]->getPbitmapBody(), imgSize);  // src

        rVal=true;
    }
    return rVal ;
}


//---------------------------------------------------------------------------
//
// EBhEEvV[W
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static UINT_PTR wTimer;
    static int loop ;
    static UINT64 begin, finish, elapsed, totalElapsed ;    // \\

    PAINTSTRUCT ps ;
    char   szBuffer[256];
    int    imgSize ;

    switch( message )
    {
        case WM_COMMAND:
            switch( LOWORD( wParam ) )
            {
                case IDM_OPEN:              // uJvj[
                    openFile(hWnd) ;
                    chgWinSize( hWnd ) ;
                    InvalidateRect( hWnd, NULL, FALSE ) ;
                    break ;

                case IDM_REDRAW:            // u̍ĕ\vj[
                    if(NULL==spCbmp[0] || NULL==spCbmp[1])
                        break;
                    imgSize=spCbmp[0]->getWidth() * spCbmp[0]->getHeight() * 4;
                                            // alignꂽGAbitmapփRs[
                    memcpy(spCbmp[0]->getPbitmapBody(),
                                        spCbmp[1]->getPbitmapBody(), imgSize);

                    InvalidateRect( hWnd, NULL, FALSE ) ;
                    break ;

                case IDM_EXEC:              // uCŎsvj[
                    totalElapsed=0;
                    loop=0;
                    pFunc=effectC;
                    if(true==doPrepareExec(hWnd))
                        wTimer = SetTimer( hWnd, ID_TIMER, 50, NULL ) ;
                    break ;

                case IDM_EXEC_ASM:         // uASMŎsvj[
                    totalElapsed=0;
                    loop=0;
                    pFunc=effectAsm;
                    if(true==doPrepareExec(hWnd))
                        wTimer = SetTimer( hWnd, ID_TIMER, 50, NULL ) ;
                    break ;

                case IDM_EXEC_SIMD:         // uSIMDŎsvj[
                    totalElapsed=0;
                    loop=0;
                    pFunc=effectSimd;
                    if(true==doPrepareExec(hWnd))
                        wTimer = SetTimer( hWnd, ID_TIMER, 50, NULL ) ;
                    break ;

                case IDM_CLOSE:             // uvj[
                    DestroyWindow( hWnd ) ;
                    break ;

                default:
                    return DefWindowProc( hWnd, message, wParam, lParam ) ;
            }
            break ;

        case WM_TIMER:
            if(++loop > NUM_OF_LOOP )
            {
                if( wTimer )
                {
                    KillTimer( hWnd, ID_TIMER ) ;
                    wTimer=0;
                }
                break ;
            }
            begin = getCurCounter();

            //摜
            pFunc( pAligned, spCbmp[0]->getWidth(), spCbmp[0]->getHeight() ) ;

            finish = getCurCounter();
            elapsed = finish > begin ? finish - begin : begin - finish ;
            totalElapsed+=elapsed;
            wsprintf( szBuffer, "loop=%d, elapsed=%I64u\n",loop,totalElapsed ) ;
            SetWindowText( hWnd, szBuffer );

            imgSize=spCbmp[0]->getWidth() * spCbmp[0]->getHeight() * 4;

            // alignꂽGAbitmapփRs[
            memcpy(spCbmp[0]->getPbitmapBody(), pAligned[0], imgSize);

            InvalidateRect( hWnd, NULL, FALSE ) ;
            break ;

        case WM_PAINT:
            if( spCbmp[0] == NULL )
                break ;
            BeginPaint( hWnd, &ps ) ;
            SetDIBitsToDevice(ps.hdc, 0, 0,     // copy BMP
                    spCbmp[0] -> getWidth(),
                        spCbmp[0] -> getHeight(),
                            0, 0, 0,
                                spCbmp[0] -> getHeight(),
                                    spCbmp[0] -> getPbitmapBody(),
                                        (PBITMAPINFO)(spCbmp[0]->getPdib()),
                                            DIB_RGB_COLORS ) ;
            EndPaint( hWnd, &ps ) ;
            break ;

        case WM_DESTROY:                        // bZ[W[vI
            if( wTimer ) KillTimer( hWnd, ID_TIMER ) ;
            SAFE_DELETE( spCbmp[0] ) ;          // IuWFNg
            SAFE_DELETE( spCbmp[1] ) ;          // IuWFNg
            SAFE_ALIGNED_FREE(pAligned[0]);     // 
            PostQuitMessage( 0 ) ;
            break;

        default:
            return DefWindowProc( hWnd, message, wParam, lParam ) ;
    }
    return 0 ;
}


//---------------------------------------------------------------------------
//
// EBhE̐
//
HWND createWindow( HINSTANCE hInstance )
{
    WNDCLASSEX  wcx ;
    HWND hWnd ;
    LPCSTR szTitle = SZCLASSNAME ;
    LPCSTR szWindowClass = SZCLASSNAME ;

    ZeroMemory( &wcx, sizeof( wcx ) ) ;         // EBhENX̓o^
    wcx.cbSize          = sizeof( WNDCLASSEX ) ;
    wcx.style           = CS_HREDRAW | CS_VREDRAW ;
    wcx.lpfnWndProc     = (WNDPROC)WndProc ;
    wcx.cbClsExtra      = 0 ;
    wcx.cbWndExtra      = 0 ;
    wcx.hInstance       = hInstance ;
    wcx.hIcon           = LoadIcon( hInstance, "ICON" ) ;
    wcx.hIconSm         = LoadIcon( hInstance, "SICON" ) ;
    wcx.hCursor         = LoadCursor( NULL, IDC_ARROW ) ;
    wcx.hbrBackground   = (HBRUSH)GetStockObject( BLACK_BRUSH ) ;
    wcx.lpszMenuName    = "MENU" ;              // j[
    wcx.lpszClassName   = szWindowClass ;
    if( !RegisterClassEx( &wcx ) )              // EBhNX̓o^
        return 0 ;                              // G[

    hWnd = CreateWindow( szWindowClass, szTitle,    // EBhE̐
                WS_OVERLAPPEDWINDOW | WS_VISIBLE,
                    CW_USEDEFAULT, CW_USEDEFAULT,
                        CW_USEDEFAULT, CW_USEDEFAULT,
                            HWND_DESKTOP, NULL,
                                hInstance, NULL ) ;

    return hWnd ;
}


//---------------------------------------------------------------------------
//
// WinMainvV[W
//
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                                           LPSTR lpCmdLine, int nCmdShow )
{
    HWND hWnd ;
    MSG msg;

    hWnd=createWindow(hInstance);
    if( !hWnd )
        return 0 ;      // G[

    while( GetMessage( &msg, NULL, 0, 0 ) != 0 )    // bZ[WE[v
    {
        TranslateMessage( &msg ) ;
        DispatchMessage( &msg ) ;
    }
    return (int)msg.wParam ;
}
